#include <iostream>
#include <cmath>
#include <map>
#include <vector>

using namespace std;

map<int, vector<int>> good_numbers;

void print_vec(vector<int> a)
{
    for(int i = 0; i < a.size(); i++) cout <<a[i] <<" ";
}

int plans(int length, int max_number, int first_element)
{
    if(length == 1)
    {
        return 1;
    }
    int answer = 0;
    for(int i = 0; i < good_numbers[first_element].size(); i++)
    {
        answer += plans(length-1, max_number, good_numbers[first_element][i]);
    }
//    for(int i = 0; i <= max_number; i++)
//    {
//        if((first_element & i) == first_element)
//        {
//            answer += plans(length-1, max_number, i);
//        }
//    }
    return answer;
}

int main()
{
    int n, m, k, ans = 0;
    cin >>n >>m >>k;
    if(m == 1)
    {
        int x,y;
        cin >>x >>y;
        cout <<2;
        return 0;
    }
    vector<int> mas[k+1];
    for(int i = 0; i <= k; i++)
    {
        for(int j = 0; j <= k; j++)
        {
            if ((i & j) == i)
            {
                mas[i].push_back(j);
            }
        }
        good_numbers.insert(pair<int, vector<int>>(i, mas[i]));
    }
    //print_vec(good_numbers[3]);
//    for(auto it = good_numbers.begin(); it != good_numbers.end(); ++it)
//    {
//        cout <<(*it).first <<" : "; print_vec((*it).second); cout <<endl;
//    }
    //return 0;
    for(int i = 0; i <= k; i++)
    {
        ans += plans(n, k, i);
    }
    cout <<ans;
    return 0;
}
